SystemOrganization addCategory: #'Path-Dev-Evaluation'!
SystemOrganization addCategory: #'Path-Dev-Example-Observer'!
SystemOrganization addCategory: #'Path-Dev-Scripts'!

MwMethodWrapper subclass: #STestCoverageWrapper
	instanceVariableNames: 'tests currentTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!STestCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 2/6/2010 15:09'!
beforeMethod
	
	self currentTest ifNotNil: [self tests add: self currentTest].! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest
	"Answer the value of currentTest"

	^ currentTest! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest: anObject
	"Set the value of currentTest"

	currentTest := anObject! !

!STestCoverageWrapper methodsFor: 'initialize-release' stamp: 'mp 1/28/2010 17:57'!
initialize

	self tests: Set new.! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests
	"Answer the value of tests"

	^ tests! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests: anObject
	"Set the value of tests"

	tests := anObject! !

Object subclass: #Driver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!Driver class methodsFor: 'demo' stamp: 'tfel 2/14/2012 10:13:15.594'!
demo
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock newOn: timer inFrame: (0@50 extent: 400@100).
	digitalClock := SDigitalClock newOn: timer inFrame: (0@150 extent: 200@210).
	1000 timesRepeat: [
		(Delay forMilliseconds: 10) wait.
		timer tick].
	(Delay forSeconds: 3) wait.
	World changed.! !

!Driver methodsFor: 'running' stamp: 'tfel 2/14/2012 10:13:10.642'!
run
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock on: timer.
	digitalClock := SDigitalClock on: timer.
	
	timer tick.! !

Object subclass: #Observer
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!Observer class methodsFor: 'as yet unclassified' stamp: 'mp 4/28/2010 14:12'!
on: aSubject
	| observer |
	observer := self new
				subject: aSubject;
				yourself.
	aSubject attach: observer.
	^ observer.! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject
	"Answer the value of subject"

	^ subject! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

!Observer methodsFor: 'observation' stamp: 'mp 4/28/2010 14:11'!
update: aSubject

	self subclassResponsibility.! !

Observer subclass: #SVisibleClock
	instanceVariableNames: 'frame para'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

SVisibleClock subclass: #SAnalogClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!SAnalogClock methodsFor: 'private' stamp: 'tfel 2/14/2012 10:11:31.204'!
draw
	| hour minute second str |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"
	str := String streamContents: [:s |
		s nextPutAll: 'H '.
		hour timesRepeat: [s nextPut: $-].
		s cr; nextPutAll: 'M '.
		minute timesRepeat: [s nextPut: $-].
		s cr; nextPutAll: 'S '.
		second timesRepeat: [s nextPut: $-]].
	self drawText: str.! !

!SAnalogClock methodsFor: 'observation' stamp: 'tfel 2/14/2012 10:11:41.446'!
update: aSubject
	aSubject = subject ifTrue: [ self draw]! !

SVisibleClock subclass: #SDigitalClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!SDigitalClock methodsFor: 'private' stamp: 'tfel 1/26/2012 21:18:21.804'!
draw
	| hour minute second |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"
	self drawText: (hour asString padded: #left to: 2 with: $0), ':',
					(minute asString padded: #left to: 2 with: $0), ':',
					(second asString padded: #left to: 2 with: $0).! !

!SDigitalClock methodsFor: 'observation' stamp: 'mp 3/19/2011 18:26:20.3'!
update: aSubject
	aSubject = subject ifTrue: [self draw]! !

!SVisibleClock class methodsFor: 'constants' stamp: 'tfel 2/14/2012 10:17:37.717'!
defaultExtent

	^ 0@50 extent: 400@100! !

!SVisibleClock class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 10:17:44.691'!
newOn: timer inFrame: frame

	^ (self on: timer)
		initInFrame: frame;
		yourself! !

!SVisibleClock class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 10:17:19.44'!
on: timer

	^ (super on: timer)
		initInFrame: self defaultExtent;
		yourself! !

!SVisibleClock methodsFor: 'private' stamp: 'tfel 1/26/2012 21:26:30.546'!
drawText: aString

	para setWithText: aString asText
		style: TextStyle default
		compositionRectangle: ((frame insetBy: 4) withHeight: 9999)
		clippingRectangle: frame
		foreColor: Color black backColor: Color white.
	para display.! !

!SVisibleClock methodsFor: 'private' stamp: 'tfel 1/26/2012 20:59:23.848'!
initInFrame: rect
	frame := rect insetBy: 2.  "Leave room for border"
	(Smalltalk hasClassNamed: #Paragraph)
		ifFalse: [^ self inform: 'MVC class Paragraph not present'].
	para := (Smalltalk at: #Paragraph) withText: '' asText
				style: TextStyle default
				compositionRectangle: ((frame insetBy: 4) withHeight: 9999)
				clippingRectangle: frame
				foreColor: Color black backColor: Color white! !

Object subclass: #SEvaluator
	instanceVariableNames: 'pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SEvaluator class methodsFor: 'constants' stamp: 'mp 9/22/2011 15:17:39.132'!
evaluatedProjects

	"^ #(aweSOM compiler z80 monticello sunit systemBrowser seaside magritte pier xml)"
"	^ #(Seaside)"
	^ #(sandbox)! !

!SEvaluator class methodsFor: 'constants' stamp: 'mp 6/23/2010 18:05'!
repetition

	^ 10! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/22/2011 17:46:12.573'!
addAuthor: aMethodReference to: aCollection
	| author |
	author := aMethodReference compiledMethod authorLastChange.
	aCollection add: author.
	^ author! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/27/2011 10:40:56.617'!
addCoverageRanking: aMethodReference to: aCollection		
	| coveredMethods coveredAuthors author ranking methodsPerAuthor rankedAuthor |
	coveredMethods := self pathMap tracer 						
								getAllCoveredMethodsFromFailedTests keys.
	coveredAuthors := coveredMethods 
							inject: Set new 
							into: [:set :meth | 
								author := meth compiledMethod authorLastChange.
								set 
									add: author; 
									yourself].
		
	ranking := (coveredAuthors collect: [:each | 
			methodsPerAuthor := coveredMethods 
				select: [:meth | meth compiledMethod lastChange first = each].
			each -> (methodsPerAuthor size / coveredMethods size)]) 
				asSortedCollection: [:a :b | a value > b value].
	rankedAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	rankedAuthor
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection 
					add: rankedAuthor value asFloat;
					add: (ranking indexOf: rankedAuthor)].
	aCollection add: ranking size.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/22/2011 17:54:04.37'!
addDeveloperRanking: aMethodReference to: aCollection	
	| author ranking opportuneAuthor overallRanking |
	author := aMethodReference compiledMethod authorLastChange.
	ranking := self pathMap tracer mostOpportuneAuthorsWith: #authorLastChange.
	opportuneAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	overallRanking := ranking inject: 0 into: [:sum :ea | sum + ea value].
	opportuneAuthor 
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection
					add: opportuneAuthor value / overallRanking;
					add: (ranking indexOf: opportuneAuthor)].
	aCollection add: ranking size.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:12:36.583'!
addMethod: aMethodReference to: aCollection
	aCollection add: aMethodReference asString.! !

!SEvaluator methodsFor: 'project' stamp: 'mp 9/22/2011 15:20:34.464'!
addProjectHeaderRowTo: aCollection
	| header |
	header := OrderedCollection new.
	header 
		add: 'Project Name';
		add: '#Categories';
		add: '#Classes';
		add: '#Methods';
		add: '#Methods Complexity > 1';
		add: 'LoC';
		add: '#Tests';
		add: 'Test Coverage'.				
	aCollection add: header.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/22/2011 18:07:14.951'!
addSuspiciousMethods: aMethodReference to: aCollection
	| suspiciousMethods method rank nextElement sameScore |
	suspiciousMethods := self pathMap tracer mostSuspiciousMethods.
	method := suspiciousMethods detect: [:assoc | assoc key = aMethodReference] ifNone: [nil].
	method
		ifNil: [4 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [
			rank := (suspiciousMethods indexOf: method).
			aCollection 
					add: method value first;
					add: rank.
				nextElement := suspiciousMethods at: rank + 1.
				sameScore := 0.
				[nextElement value first = method value first] 
					whileTrue: [	sameScore := sameScore + 1.
								nextElement := suspiciousMethods 
													at: rank + 1 + sameScore].
				aCollection add: sameScore.
				aCollection add: suspiciousMethods size.].
	
	! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 7/7/2010 16:54:32.473'!
addTestMeasurmentsTo: aCollection
	| tests measurements | 
	tests := SProject current allTestsWithoutLongRunning.
	tests 
		do: [:each | 
			measurements := OrderedCollection new.
			self 
				measureCommonTestBehavior: each on: measurements;
				measureShallowAnalysis: each on: measurements;
				measureRefinementAnalysis: each on: measurements.
			aCollection add: measurements] 
		displayingProgress: 'Run Test Measurements of ', SProject current projectName asString.	! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:16:42.036'!
addTestResultsTo: aCollection
	aCollection
		add: self pathMap tracer allPassed;
		add: self pathMap tracer allFailures.! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 14:07'!
convertCollectionToCSV: aCollection  on: aStream

	aCollection withIndexDo: [:row :index |
		aStream nextPutAll: index asString.
		aStream nextPut: $,.
		row do: [:column | 
			aStream nextPutAll: column asString.
			aStream nextPut: $,.].
		aStream cr; flush.].
	! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 3/27/2012 16:13:39.169'!
createDynamicTracerModel

	| tracer model |
	tracer := SCallgraphTracer on: SProject current.
	model := SCallgraphModel on: tracer.
	tracer callgraphModel: model.	
	^ tracer! !

!SEvaluator methodsFor: 'project' stamp: 'mp 9/22/2011 15:18:51.824'!
currentProjectStatistics
	| stats |
	stats := OrderedCollection new.
	stats 
		add: SProject current projectName;
		add: SProject current nop;
		add: SProject current noc;
		add: SProject current nom;
		add: SProject current nomWithoutLowComplexity;
		add: SProject current loc;
		add: SProject current allTestsWithoutLongRunning size;
		add: self getTestCoverage;
		yourself.
	^ stats! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 15:16:14.412'!
developerRanking: aCollection forProject: aProjectName
	self do: [
		aCollection 
			add: (OrderedCollection with: aProjectName);
			add: self developerRankingHeaderRow;
			yourself.
		self developerRankingEvaluationTo: aCollection]
		withCurrentProject: aProjectName.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/22/2011 17:56:35.284'!
developerRankingEvaluationTo: aCollection
	| coveredMethods row wrapper |
	self initializePathMap.
	coveredMethods := self methodsCoveredByTests asSortedCollection.
	((1 to: (coveredMethods size // 50) + 1) collect: [:each | each - 1 * 50 + 1 ])
		do: [:start | | stop |
	stop := start + 49.
	stop := stop min: coveredMethods size.
	(coveredMethods copyFrom: start to: stop) do: [:each | 
		Transcript show: DateAndTime now; space; show: each asString; cr.
		row := OrderedCollection new.
		[wrapper := SBlockMethodWrapper 
						on: each methodSymbol inClass: each actualClass.
		wrapper install.
		[self pathMap runAllTestsWith: #faultLocalization.
		self 
			addMethod: each to: row;
			addAuthor: each to: row;
			addTestResultsTo: row;
			addSuspiciousMethods: each to: row;
			addDeveloperRanking: each to: row;
			addCoverageRanking: each to: row]
		on: Error do: [:e | row add: 'Error thrown!!']
		] ensure: [
			wrapper uninstall.
			self pathMap tracer: nil.
			Smalltalk garbageCollect].
		aCollection add: row]
		displayingProgress: 'Run developer ranking for ', 
							coveredMethods size asString, 
							' methods.'.
		"Store collection"			
		self storeCollection: aCollection 
			 asCSVFile: start asString, '-', stop asString, '_developerRanking.csv'	].! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/22/2011 18:04:41.895'!
developerRankingHeaderRow
	^ OrderedCollection new
		add: 'Method';
		add: 'Author';
		add: 'Passed';
		add: 'Failed';
		add: 'Suspiciousness';
		add: 'Method rank';
		add: 'Methods with same suspiciousness';
		add: 'Number of suspicious methods';
		add: 'FL Developer rating';
		add: 'FL Author rank';
		add: 'FL Number of authors';
		add: 'Coverage rating';
		add: 'Coverage rank';
		add: 'Coverage number of authors';
		yourself! !

!SEvaluator methodsFor: 'project' stamp: 'mp 7/7/2010 16:54:59.333'!
do: aBlock withCurrentProject: aProjectName
	| previousCurrentProject result |
	[previousCurrentProject := SProject current.
	SProject setCurrent: aProjectName.
	result := aBlock value]
		ensure: [SProject setCurrentProject: previousCurrentProject].
	^ result! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 6/23/2010 18:48'!
getCurrentMemoryConsumption
	"Browse: [SmalltalkImage vmStatisticsReportString]"
	| params youngSpaceEnd |
	Smalltalk garbageCollect.
	params := SmalltalkImage current getVMParameters.
	youngSpaceEnd := params at: 2.
	^ youngSpaceEnd! !

!SEvaluator methodsFor: 'project' stamp: 'mp 9/22/2011 15:20:55.634'!
getTestCoverage
	| tests wrappers coverage |
	tests := SProject current allTestsWithoutLongRunning collect: [:each | STestCaseEntryPoint onTestMethodReference: each].
	wrappers := self installWrappersOfType: STestCoverageWrapper.
	[tests 
		do: [:each | wrappers do: [:wrapper | wrapper currentTest: each].
			each execute] 
		displayingProgress: 'Run Tests for Coverage of ', SProject current projectName asString.
	coverage := (wrappers select: [:each | each tests notEmpty]) size / SProject current nom]
	ensure: [wrappers do: [:each | each uninstall].
		      STestCoverageWrapper nuke.
		      Smalltalk garbageCollect].
	^ coverage asFloat! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 15:37:42.709'!
initializePathMap
	| testRunner |
	testRunner := ToolBuilder build: SPathMapTestRunner new.
	self pathMap: testRunner model pathMap.
	self pathMap globalOptions
		switchShowQuickAndAccessorMethods;
		switchShowMethodCategories;
		switchVisualizeIntermediateSteps.! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 7/7/2010 16:54:52.849'!
installWrappersOfType: aClass

	| wrappers wrapper |
	wrappers := OrderedCollection new.
	SProject current allMethods do: [:each | 
		wrapper := aClass on: each methodSymbol inClass: each actualClass.
		wrapper ifNotNil: [wrappers add: wrapper]].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/23/2010 18:12'!
measureCommonTestBehavior: aTestReference on: aCollection

	aCollection 
		add: aTestReference asStringOrText;
		add: (self runTest: aTestReference) hasPassed asString;
		add: [self class repetition timesRepeat: [self runTest: aTestReference]] timeToRun;
		yourself.! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/24/2010 08:56'!
measureRefinementAnalysis: aTestReference on: aCollection
	| tracer callNode id |
	tracer := self createDynamicTracerModel.
	tracer traceTest: aTestReference actualClass method: aTestReference methodSymbol.
	id :=  ((tracer currentId - 1) / 2) asInteger.
	id <= 0 "e.g. ClassTestCase triggers no behavior in partial traces"
		ifTrue: [aCollection add: 'N/A']
		ifFalse: [	
			callNode := tracer getNode: id.
			aCollection add: [tracer explore: #return on: callNode] timeToRun.].
	Smalltalk garbageCollect.		! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/24/2010 17:39'!
measureShallowAnalysis: aTestReference on: aCollection
	| tracer result runtime bytesBefore |
	bytesBefore := self getCurrentMemoryConsumption.
	tracer := self createDynamicTracerModel.
	runtime := [result := tracer 
						traceTest: aTestReference actualClass 
						method: aTestReference methodSymbol] timeToRun.
	aCollection
		add: result hasPassed;
		add: runtime;
		add: tracer currentId;
		add: self getCurrentMemoryConsumption - bytesBefore.
	tracer := nil.
	Smalltalk garbageCollect.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/23/2011 17:51:42.147'!
methodsCoveredByTests
	^ self methodsCoveredByTestsOn: #testQuality.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 9/23/2011 17:51:20.989'!
methodsCoveredByTestsOn: aSymbol
	self pathMap runAllTestsWith: aSymbol.
	^ self pathMap tracer getAllCoveredMethods keys 
		reject: [:each | ((each methodSymbol beginsWith: 'test') 
						or: [each compiledMethod isQuick])
						or: [each actualClass inheritsFrom: TestCase]].! !

!SEvaluator methodsFor: 'accessing' stamp: 'mp 2/8/2011 15:28:52.59'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SEvaluator methodsFor: 'accessing' stamp: 'mp 2/8/2011 15:28:52.632'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SEvaluator methodsFor: 'project' stamp: 'mp 6/23/2010 13:56'!
projectStatisticsFor: aProjectName

	^ self do: [self currentProjectStatistics] withCurrentProject: aProjectName

! !

!SEvaluator methodsFor: 'refined fault localization' stamp: 'mp 9/23/2011 17:46:40.381'!
refinedFaultLocalization: aCollection forProject: aProjectName
	self do: [
		aCollection 
			add: (OrderedCollection with: aProjectName);
			add: self refinedFaultLocalizationHeaderRow;
			yourself.
		self refinedFaultLocalizationEvaluationTo: aCollection]
		withCurrentProject: aProjectName.! !

!SEvaluator methodsFor: 'refined fault localization' stamp: 'mp 9/27/2011 10:42:41.386'!
refinedFaultLocalizationEvaluationTo: aCollection
	| coveredMethods browser row begin |
	self initializePathMap.
	coveredMethods := ((self methodsCoveredByTestsOn: #faultLocalization) 
							select: [:each | each compiledMethod complexity > 1]) 
								asSortedCollection.
	coveredMethods do: [:each | 
		[Transcript show: DateAndTime now; space; show: each asString; cr.
		row := OrderedCollection new.
		browser := SystemBrowser default 
					fullOnClass: each actualClass selector: each methodSymbol.
		row 
			add: each asString;
			add: each compiledMethod complexity;
			add: each compiledMethod coveringTests size.
		begin := DateAndTime now.
		browser faultLocalizationAtStatements: self pathMap tracer.
		row add: DateAndTime now - begin.
		browser dependents first abandon.]
			on: Error do: [:e | row add: 'Error thrown!!'].
		aCollection add: row]
		displayingProgress: 'Run fault localization refinement for ', 
							coveredMethods size asString, 
							' methods.'.	! !

!SEvaluator methodsFor: 'refined fault localization' stamp: 'mp 9/23/2011 17:47:37.752'!
refinedFaultLocalizationHeaderRow
	^ OrderedCollection new
		add: 'Method';
		add: 'Complexity';
		add: '#Tests';
		add: 'run-time in ms';
		yourself! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 9/22/2011 16:20:09.351'!
runTest: aTestMethodReference
	^ (STestCaseEntryPoint onTestMethodReference: aTestMethodReference) execute! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 14:08'!
storeCollection: aCollection asCSVFile: aFileName
	| file |
	[file := FileDirectory default forceNewFileNamed: aFileName.
	 self convertCollectionToCSV: aCollection  on: file]
	ensure: [file close].! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 2/8/2011 15:11:53.994'!
storeDeveloperRanking
	| measurements |
	measurements := OrderedCollection new.
	self class evaluatedProjects do: [:each | self 
												developerRanking: measurements 
												forProject: each].
	self storeCollection: measurements asCSVFile: '_developerRanking.csv'.
	^ measurements! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 17:00'!
storeProjectStatisticsOfAllProjects

	| stats |
	stats := OrderedCollection new.
	self addProjectHeaderRowTo: stats.
	self class evaluatedProjects do: [:each | stats add: (self projectStatisticsFor: each)].
	self storeCollection: stats asCSVFile: '_projects.csv'.
	^ stats! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 9/23/2011 18:05:05.873'!
storeRefinedFaultLocalization
	| measurements |
	measurements := OrderedCollection new.
	self class evaluatedProjects do: [:each | self 
												refinedFaultLocalization: measurements 
												forProject: each].
	self storeCollection: measurements asCSVFile: '_refinedFaultLocalization.csv'.
	^ measurements! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 17:16'!
storeTestMeasurementsOfAllProjects

	| measurements |
	measurements := OrderedCollection new.
	self class evaluatedProjects do: [:each | self testMeasurements: measurements forProject: each].
	self storeCollection: measurements asCSVFile: '_testMeasurements.csv'.
	^ measurements! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 9/22/2011 16:20:44.259'!
testMeasurementHeaderRow

	^ OrderedCollection new
		add: 'test name';
		add: 'test passed';
		add: ('test run-time x, ', self class repetition);
		add: 'SA test passed';
		add: 'SA run-time';
		add: 'SA call nodes';		
		add: 'SA memory';
		add: 'RA run-time';
		yourself									! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/23/2010 17:44'!
testMeasurements: aCollection forProject: aProjectName
	^ self do: [
		aCollection 
			add: (OrderedCollection with: aProjectName);
			add: self testMeasurementHeaderRow;
			yourself.
		self addTestMeasurmentsTo: aCollection] 
		withCurrentProject: aProjectName.! !

Object subclass: #SEvaluatorDeprecated
	instanceVariableNames: 'selectedCategories projectName'
	classVariableNames: 'Repetition'
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/13/2010 20:33'!
convertCollectionToCSV: aCollection on: aStream

	| index |
	index := 1.
	aCollection do: [:each |
		aStream nextPutAll: index asString.
		aStream nextPut: $,.
		aStream nextPutAll: each key asStringOrText.
		aStream nextPut: $,.
		aStream nextPutAll: each value asString.
		aStream cr; flush.
		index := index + 1].! !

!SEvaluatorDeprecated class methodsFor: 'example' stamp: 'mp 6/23/2010 13:34'!
example
	"Do it"

	"TEST RUN-TIME"
	| file |
	file := FileDirectory default forceNewFileNamed: 'MonticelloTestsRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello testRuntime  on: file.
	file close.

	"ON DEMAND REFINEMENT"
	file := FileDirectory default forceNewFileNamed: 'MonticelloSpecificWrapperRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello specificWrapperRuntime  on: file.
	file close.

	"CORE ANALYSIS"
	file := FileDirectory default forceNewFileNamed: 'MonticelloCallWrapperRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello callWrapperRuntime  on: file.
	file close.

	"FULL ANALYSIS"
	file := FileDirectory default forceNewFileNamed: 'MonticelloFullTraceRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello fullExploreStateAndViewProfileWrapperRuntime  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectMonticello

	^ self new
		projectName: 'Monticello';
		selectedCategories:  #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectSUnit

	^ self new
		projectName: 'SUnit';	
		selectedCategories:  #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/6/2010 19:26'!
projectSWA

	^ self new
		projectName: 'SWA';	
		selectedCategories:  #(#'Swa-DoubleDispatch')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectSystemBrowser

	^ self new
		projectName: 'SystemBrowser';	
		selectedCategories:   #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:44'!
projectZ80

	^ self new
		projectName: 'Z80';	
		selectedCategories: #(#Z80 #'Z80-Assembler' #'Z80-Peripherals' #'Z80-Tests')! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 5/5/2010 21:31'!
repetition

	^ Repetition! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/6/2010 19:32'!
run: anEvaluator on: aStream

	aStream nextPutAll: 'Number of Classes: '.
	aStream nextPutAll: anEvaluator numberOfClasses asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Methods '.
	aStream nextPutAll: anEvaluator numberOfMethods asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Lines of Code: '.
	aStream nextPutAll: anEvaluator linesOfCode  asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Tests: '.
	aStream nextPutAll: anEvaluator numberOfTests  asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Test Coverage: '.
	aStream nextPutAll: anEvaluator testCoverage asFloat asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Method Calls per Test:  '.
	aStream nextPutAll: anEvaluator numberOfMethodCallsPerTest asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests: '.
	aStream nextPutAll: anEvaluator testRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests with Call Tracer: '.
	aStream nextPutAll: anEvaluator callWrapperRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests with View/Profile Tracer: '.
	aStream nextPutAll: anEvaluator viewProfileWrapperRuntime asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Run-time of Tests with Specific Explore Wrapper: '.
	aStream nextPutAll: anEvaluator specificWrapperRuntime asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Run-time of Tests with Full Instrumentation: '.
	aStream nextPutAll: anEvaluator fullExploreStateAndViewProfileWrapperRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption of Tests with Call Tracer:'.
	aStream nextPutAll: anEvaluator callWrapperMemory asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption of Tests with View/Profile Tracer:'.
	aStream nextPutAll: anEvaluator viewProfileWrapperMemory asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption with Full Instrumentation: '.
	aStream nextPutAll: anEvaluator fullExploreStateAndViewProfileWrapperMemory asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Set Up Costs'.
	aStream nextPutAll: anEvaluator setUpCosts asString.
	aStream cr.
	aStream flush.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestMemoryShallowAnalysis
	" self runAllProjectTestShallowAnalysis"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectSUnit testShallowAnalysisMemory  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectMonticello testShallowAnalysisMemory  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectZ80 testShallowAnalysisMemory  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestRefinementAnalysis
	" self runAllProjectTestRuntimes"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectSUnit testRefinementAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectMonticello testRefinementAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectZ80 testRefinementAnalysis  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestRuntimes
	" self runAllProjectTestRuntimes"
	| file |
	Repetition := 100.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestRuntime_100.csv'.
	self convertCollectionToCSV: self projectSUnit testRuntime  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestRuntime_100.csv'.
	self convertCollectionToCSV: self projectMonticello testRuntime  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestRuntime_100.csv'.
	self convertCollectionToCSV: self projectZ80 testRuntime  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestShallowAnalysis
	" self runAllProjectTestShallowAnalysis"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectSUnit testShallowAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectMonticello testShallowAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectZ80 testShallowAnalysis  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/6/2010 15:35'!
runAllProjectsOn: aStream

	aStream clear.
	aStream nextPutAll: '--------------- Project SUnit --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectSUnit on: aStream.
	aStream cr; cr.
	aStream flush.

	aStream nextPutAll: '--------------- Project System Browser --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectSystemBrowser on: aStream.
	aStream cr; cr.
	aStream flush.
	
	aStream nextPutAll: '--------------- Project Monticello --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectMonticello on: aStream.
	aStream cr; cr.
	aStream flush.
	
	aStream nextPutAll: '--------------- Project Z80 --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectZ80 on: aStream.
	aStream cr; cr.
	aStream flush.
	
	! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runMonticelloProjectTestGUIStartUp
	"self runMonticelloProjectTestGUIStartUp"
	| file |
	file := FileDirectory default forceNewFileNamed: '__MonticelloTestGuiStartUp.csv'.
	self convertCollectionToCSV: self projectMonticello testGUIStartUpTime  on: file.
	file close.! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 17:34'!
callWrapperMemory

	| tracer tests memory bytesBefore |
	tracer := self createDynamicTracerModel.
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			tracer traceTest: each actualClass method: each methodSymbol.
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:52'!
callWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			stopWatch reset.
			stopWatch activate.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of Lightweight Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 3/27/2012 16:13:33.001'!
createDynamicTracerModel

	| tracer model |
	tracer := SCallgraphTracer on: self selectedCategories. "This must be adapted #on: now expects a project"
	model := SCallgraphModel on: tracer.
	tracer callgraphModel: model.	
	^ tracer! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 7/7/2010 16:37:21.284'!
createExploreWrapperOn: aTracer

	| wrappers |
	wrappers := OrderedCollection new.
	self getAllMethods do: [:each | wrappers add: (SExploreEvaluationWrapper 
										on: each methodSymbol 
										inClass: each actualClass 
										withTracer: aTracer)].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 19:35'!
fullExploreStateAndViewProfileWrapperMemory

| tracer tests memory bytesBefore wrappers |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.	
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			wrappers := self createExploreWrapperOn: tracer.
			tracer traceTest: each actualClass method: each methodSymbol.
			wrappers do: [:wrapper | wrapper uninstall].
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Full Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/16/2010 19:59'!
fullExploreStateAndViewProfileWrapperRuntime

	| tracer tests runtime stopWatch wrappers |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			stopWatch reset.
			stopWatch activate.
			wrappers := self createExploreWrapperOn: tracer.
			tracer traceTest: each actualClass method: each methodSymbol.
			wrappers do: [:wrapper | wrapper uninstall].
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			Transcript show: stopWatch duration asString; cr.
			Smalltalk garbageCollect.
			] 
		displayingProgress: 'Run Tests for Run-time of Full Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/5/2010 16:53'!
getAllMethods

	| methods |
	methods := OrderedCollection new.
	self getAllProjectClasses do: [:klass | 
		klass methodDict keysDo: [:aSelector | 
			methods add: (MethodReference class: klass selector: aSelector)].
		klass class methodDict keysDo: [:aSelector | 
			methods add: (MethodReference class: klass class selector: aSelector)]].
	^ methods! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/5/2010 16:45'!
getAllProjectClasses

	^ Smalltalk allClasses select: [:each | self selectedCategories includes: each category]! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 17:05'!
getAllTestMethods

	^ self getAllMethods select: [:each | ((each methodSymbol beginsWith: 'test') and: [each actualClass inheritsFrom: TestCase]) and: [each methodSymbol numArgs = 0]].! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 17:35'!
getCurrentMemoryConsumption
	"Browse: [SmalltalkImage vmStatisticsReportString]"
	| params youngSpaceEnd |
	Smalltalk garbageCollect.
	params := SmalltalkImage current getVMParameters.
	youngSpaceEnd := params at: 2.
	^ youngSpaceEnd
	! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 22:37'!
getResultsFrom: aCollection

	| results sortedCollection startValue |
	startValue := 0.
	(aCollection first value isKindOf: Duration)
		ifTrue: [startValue := startValue asDuration].
	results := Dictionary new.
	results 
		at: #average 
		put: ((aCollection inject: startValue into: [:sum :each | sum := sum + each value]) / aCollection size).
	sortedCollection := aCollection asSortedCollection: [:a :b | a value < b value].
	results
		at: #min
		put: sortedCollection first value.
	results
		at: #max
		put: sortedCollection last value.
	results
		at: #median
		put: sortedCollection median value.	
	^ results! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 14:54'!
installWrappersOfType: aClass

	| wrappers |
	wrappers := OrderedCollection new.
	self getAllMethods do: [:each | wrappers add: (aClass on: each methodSymbol inClass: each actualClass)].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:56'!
linesOfCode

	^ self getAllMethods inject: 0 into: [:sum :each | sum := sum + each compiledMethod linesOfCode].! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:46'!
numberOfClasses

	^ self getAllProjectClasses size.! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 2/13/2010 20:22'!
numberOfMethodCallsPerTest

	| tracer tests callNodes |
	tracer := self createDynamicTracerModel.
	callNodes := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			tracer traceTest: each actualClass method: each methodSymbol.
			callNodes add: each -> tracer nextId.
			] 
		displayingProgress: 'Run Tests for Method Calls per Test'.
	Smalltalk garbageCollect.
	^ callNodes
	"^ self getResultsFrom: callNodes"! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:49'!
numberOfMethods

	^ self getAllMethods size! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 2/6/2010 14:31'!
numberOfTests

	^ self getAllTestMethods size ! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:43'!
projectName
	"Answer the value of projectName"

	^ projectName! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:43'!
projectName: anObject
	"Set the value of projectName"

	projectName := anObject! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:23'!
selectedCategories
	"Answer the value of selectedCategories"

	^ selectedCategories! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:23'!
selectedCategories: anObject
	"Set the value of selectedCategories"

	selectedCategories := anObject! !

!SEvaluatorDeprecated methodsFor: 'setup costs' stamp: 'mp 2/6/2010 18:08'!
setUpCosts

	| tracer test stopWatch wrappers |
	tracer := self createDynamicTracerModel.
	test := self getAllTestMethods first.
	stopWatch := Stopwatch new.
	stopWatch activate.
	
	tracer createNewCallgraphOn: test actualClass with: test methodSymbol.
	wrappers := tracer createWrappers.
	tracer startTracing.
	"Run Test"
	tracer 
		stopTracing;
		removeWrappers: wrappers.
	stopWatch suspend.
	^ stopWatch duration! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:49'!
specificWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch reset.
			stopWatch activate.
			[tracer explore: #return on: (tracer getNode: tracer currentId atRandom)] on: Error do: [:signal | ].
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of Specific Exploring'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 7/7/2010 17:06:05.288'!
testCoverage

	| tests wrappers coverage |
	tests := self getAllTestMethods.
	wrappers := self installWrappersOfType: STestCoverageWrapper.
	tests 
		do: [:each | 
			wrappers do: [:wrapper | wrapper currentTest: each].
			each actualClass run: each methodSymbol] 
		displayingProgress: 'Run Tests for Coverage'.
	coverage := (wrappers select: [:each | each tests notEmpty]) size / self getAllMethods size.
	wrappers do: [:each | each uninstall].
	Smalltalk garbageCollect.
	^ coverage! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 7/8/2010 17:21:05.641'!
testGUIStartUpTime

	| tests  runtime |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			runtime add: each -> (SPathFinder openWithPerformanceMesaureOn: each)] 
		displayingProgress: 'Run Tests for Test Run-time'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/5/2010 23:07'!
testRefinementAnalysis

	| tests  runtime tracer callNode |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tracer := self createDynamicTracerModel.
	tests 
		do: [:each | 
			tracer traceTest: each actualClass method: each methodSymbol.
			callNode := tracer getNode: (tracer currentId - 1).
			runtime add: each -> ([self class repetition	
								timesRepeat: [tracer explore: #return on: callNode]] timeToRun)] 
		displayingProgress: 'Run Tests for Run-time of Specific Exploring'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/4/2010 16:00'!
testRuntime

	| tests  runtime |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			runtime add: each -> ([self class repetition 
								timesRepeat: [each actualClass run: each methodSymbol]] timeToRun)] 
		displayingProgress: 'Run Tests for Test Run-time'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/5/2010 22:23'!
testShallowAnalysis

	| tests  runtime tracer |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tracer := self createDynamicTracerModel.
	tests 
		do: [:each | 
			runtime add: each -> ([self class repetition 
					timesRepeat: [tracer traceTest: each actualClass method: each methodSymbol]] timeToRun)] 
		displayingProgress: 'Run Tests for Run-time of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/6/2010 08:55'!
testShallowAnalysisMemory

	| tracer tests memory bytesBefore results |
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			results := OrderedCollection new.
			bytesBefore := self getCurrentMemoryConsumption.
			self class repetition timesRepeat: [			
					tracer := self createDynamicTracerModel.
					tracer traceTest: each actualClass method: each methodSymbol.
					results add: tracer].			
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			results := nil.
			Smalltalk garbageCollect.
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ memory! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 17:52'!
viewProfileWrapperMemory

	| tracer tests memory bytesBefore |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			tracer traceTest: each actualClass method: each methodSymbol.
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Profile/View Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:54'!
viewProfileWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			stopWatch reset.
			stopWatch activate.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of View/Profile Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

Object subclass: #SScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Scripts'!

!SScripts class methodsFor: 'access' stamp: 'mp 2/3/2012 14:24:56.084'!
bucketsOfCurrentProject
	"self typesOfCurrentProject"
	SProject current harvestedBuckets explore.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 19:24:23.514'!
buildOmniBrowserSAR
	
	self
		buildSARFrom: { 'OmniBrowser'. 'OB-Morphic'. 'OB-Standard'. 'AST'. 'Refactoring'. 'OB-Refactory'. 
							'OB-Refactoring'. 'OB-Regex'. 'OB-SUnitIntegration'. 'OB-Shout' }
		to: 'OmniBrowser.sar'
		withExtensions: {}
		withClasses: {}
		additionalPreamble: ''.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/12/2011 17:15:53.33'!
buildPathViewSAR
	
	self
		buildSARFrom: { 'SwaUtil'. 'MethodWrappers'. 'Animations'. 'TypeHarvesting'. 'FSM-Base'. 
						 'FSM-Morphic'. 'FSM-Events'. 'Connectors'. 'SSpec'. 'SightL-Tracer'. 'ConnectorsShapes'.
						 'ConnectorsText'. 'SightL-Projects'. 'SightL-Morphic'.
						 'cgprereqs-structure'. 'SightL-PV' }
		to: 'PathView.sar'
		withExtensions: { 'SightL' }
		withClasses: { STool. SPathView. SPathViewDiagramSpec. SDefinitionModel.
			 SProjectChooser. SProject. SCategoryChooser. SConcernChooser. STracer. UiIcons. UiFugueIcons 
		}
		additionalPreamble: 'NCAAConnectorMorph withAllSubclassesDo: [ :cl | cl initializeArrowDictionary ]'.! !

!SScripts class methodsFor: 'building' stamp: 'mp 6/1/2011 17:44:03.125'!
buildSAR
		| packages zip mczStream workingCopy version preamble |
	packages := {'MethodWrappers'. 'Animations'. 'TypeHarvesting'. 'SightL'}.
	zip := ZipArchive new.
	packages do: [:each | 
		mczStream := RWBinaryOrTextStream on: (String new: 100000). 	
		workingCopy := MCWorkingCopy forPackage: (MCPackage new name: each). 
		version := workingCopy newVersion. 
		version fileOutOn: mczStream.
		(zip addString: mczStream contents as: each, '.mcz') desiredCompressionLevel: 0].
	zip 
		addFile: 'ClosureExtractor.st';
		addFile: 'CompiledMethod-embeddedBlockMethods.st'.	
	preamble :=  'self fileInPackageNamed: ''ClosureExtractor.st''.'.
	preamble := preamble, 'self fileInPackageNamed: ''CompiledMethod-embeddedBlockMethods.st''.'.
	preamble := preamble, (packages 
					inject: String new 
					into: [:str :each | str := str, 'self fileInMonticelloZipVersionNamed: ''', each, '.mcz''.']).
	preamble := preamble, 'SProject setCurrent: #observerExample.'.
	zip addString: preamble as: 'install/preamble'. 
	zip writeToFileNamed: 'PathTools.sar'.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/3/2011 17:00:10.934'!
buildSARFrom: packages to: filename additionalPreamble: aString
	
	self buildSARFrom: packages to: filename withExtensions: {} withClasses: {} additionalPreamble: aString.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:38:58.011'!
buildSARFrom: packages to: filename withExtensions: additionalExtensions withClasses: additionalClasses additionalPreamble: aString
	
	| zip preamble additionalSource |
	zip := ZipArchive new.
	additionalSource := WriteStream on: ''.
	preamble := WriteStream on: ''.
	packages do: [:each | | stream |
		stream := RWBinaryOrTextStream on: ''..
		self writeMcz: each on: stream.
		(zip addString: stream contents as: each, '.mcz') desiredCompressionLevel: 0. "Default is 6..."
		self fileOutExtensionsOf: each on: additionalSource skipping: additionalClasses.
		preamble nextPutAll: 'self fileInMonticelloZipVersionNamed: '''; nextPutAll: each; nextPutAll: '.mcz''.' ].
	additionalClasses do: [ :cl | cl fileOutOn: additionalSource moveSource: false toFile: 0 ].
	additionalExtensions do: [ :each | self fileOutExtensionsOf: each on: additionalSource skipping: additionalClasses ].
	preamble
		nextPutAll: 'self fileInPackageNamed: ''additionalSource.st''.';
		nextPutAll: aString.
	zip
		addString: additionalSource contents as: 'additionalSource.st';
		addString: preamble contents as: 'install/preamble';
		writeToFileNamed: filename.! !

!SScripts class methodsFor: 'menu' stamp: 'mp 3/8/2012 10:54:29.904'!
chooseScript
	"self chooseScript"
	| allScripts notListedSelectors |
	notListedSelectors := {#chooseScript. #label. #createButton. #isOn}.
	allScripts := (self class methodDict keys 
					reject: [:each | (notListedSelectors includes: each)
									or: [each includes: $:]]) sort.
	(UIManager default chooseFrom: allScripts title: 'Choose script to do it')
		ifNotNilDo: [:choice | 
			choice > 0
				ifTrue: [self perform: (allScripts at: choice)]]
	! !

!SScripts class methodsFor: 'clean up' stamp: 'mp 3/8/2012 15:29:09.921'!
countInstances
	"self countInstances"
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	({MwMethodWrapper. SCallNode. SPMPathMapMorph. SClassMorph. SClassDiagramMorph. SMiniMap. SStateViewTracer}
		inject: Dictionary new into: [:dict :each | 
			dict 
				at: each put: each allSubInstances size;
				yourself]) explore.! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:59:11.852'!
createButton
	"self createButton"
	(PluggableButtonMorphPlus 
		on: SScripts 
		getState: #isOn 
		action: #chooseScript 
		label: #label) openInHand! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:40:13.732'!
examplePathState
	"self examplePathState"
	(SStateViewTracer 
	onClass: SOMInterpreter 
	instVarName: #frame) run valuesAsSet explore.! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:38:39.685'!
examplePathView
	"self examplePathView"
	SPathView openOn: SOMInterpreter.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/3/2011 17:02:44.386'!
fileOutExtensionsOf: packageName on: stream skipping: skippedClasses
	
	| categoryName |
	categoryName := ('*', packageName) asSymbol.
	Smalltalk allClasses
		select: [ :cl | 
			(skippedClasses includes: cl) not and: [ cl organization categories includes: categoryName ] ]
		thenDo: [ :cl |
			cl fileOutCategory: categoryName on: stream moveSource: false toFile: 0 ].! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:25.573'!
isOn
	^ true! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:13.313'!
label
	^ 'PathScripts'! !

!SScripts class methodsFor: 'clean up' stamp: 'mp 3/8/2012 10:58:00.307'!
nuke
	"self nuke"
	MwMethodWrapper nuke.
	SMiniMap allInstances do: [:each | each abandon].
	SClassDiagramMorph allSubInstances do: [:each | each abandon].
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	self assert: [MwMethodWrapper allSubInstances size = 0].
	self assert: [SMiniMap allInstances size = 0]. 
	self inform: 'Clean up done'! !

!SScripts class methodsFor: 'access' stamp: 'mp 2/24/2011 17:44:18.439'!
typesOfCurrentProject
	"self typesOfCurrentProject"
	SProject current typesBucket explore.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:43:12.743'!
writeMcz: aPackageName
	
	^ self writeMcz: aPackageName on: (FileStream forceNewFileNamed: aPackageName, '.mcz')! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:39:24.748'!
writeMcz: aPackageName on: aStream
	
	^ (MCPackage named: aPackageName) workingCopy newVersion fileOutOn: aStream! !

Object subclass: #Subject
	instanceVariableNames: 'observers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

Subject subclass: #ClockTimer
	instanceVariableNames: 'hour minute second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour
	"Answer the value of hour"

	^ hour! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour: anObject
	"Set the value of hour"

	hour := anObject! !

!ClockTimer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 15:06:34.806'!
initialize
	| time |
	super initialize.
	time := Time midnight.
	hour := time hour.
	minute := time minute.
	second := time second.! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute
	"Answer the value of minute"

	^ minute! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute: anObject
	"Set the value of minute"

	minute := anObject! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second
	"Answer the value of second"

	^ second! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second: anObject
	"Set the value of second"

	second := anObject! !

!ClockTimer methodsFor: '-- all --' stamp: 'mp 4/28/2010 13:55'!
tick
	"update internal time-keeping state"
	| time |
	time := (Time hour: hour minute: minute second: second) addSeconds: 1.
	hour := time hour.
	minute := time minute.
	second := time second.
	self notify.! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:14'!
attach: anObserver
	observers add: anObserver! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:15'!
detach: anObserver
	observers remove: anObserver! !

!Subject methodsFor: 'initialize-release' stamp: 'fg 4/12/2010 15:14'!
initialize
	observers := OrderedCollection new! !

!Subject methodsFor: 'observation' stamp: 'mp 4/28/2010 13:32'!
notify
	observers do: [ :obs | obs update: self ].! !

TestCase subclass: #TestDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!TestDriver methodsFor: 'running' stamp: 'tfel 2/14/2012 10:18:16.75'!
tearDown

	super tearDown.
	World changed.! !

!TestDriver methodsFor: 'testing' stamp: 'mp 9/29/2010 14:02:17.276'!
testNoop

	self assert: self class == TestDriver! !

!TestDriver methodsFor: 'testing' stamp: 'tfel 2/14/2012 10:13:19.64'!
testRun
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock on: timer.
	digitalClock := SDigitalClock on: timer.
	
	timer tick.! !

SWrapper subclass: #SBlockMethodWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SBlockMethodWrapper methodsFor: 'evaluating' stamp: 'mp 9/29/2011 15:52:05.335'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	^ anObject! !

SCallWrapper subclass: #SExploreEvaluationWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
afterMethod! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/16/2010 20:15'!
aroundWithReceiver: aReceiver arguments: anArrayOfObjects
	
	| result types |
	"#arguments #selfBefore #selfAfter #return #types"
	self tracer isActive ifTrue: [
		self tracer stopTracing.
		anArrayOfObjects isEmpty not
			ifTrue: [	types := OrderedCollection new.
					anArrayOfObjects do: [:each | types add: each class].
					types add: aReceiver class.
					self tracer addView: types to: #types.
					"self tracer addView: anArrayOfObjects veryDeepCopy to: #arguments.
					self tracer addView: aReceiver veryDeepCopy to: #selfBefore."
					].
		self tracer startTracing].
	^ [result := self proceed: aReceiver arguments: anArrayOfObjects.
	     result]
		ensure: [ 	
			self tracer isActive ifTrue: [
				self tracer stopTracing.
				"self tracer addView: aReceiver veryDeepCopy to: #selfAfter.
				self tracer addView: result veryDeepCopy to: #result."
				self tracer addView: result class to: #resultType.
				self tracer startTracing]]! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
beforeMethod! !
